<script lang="ts" setup>
import {ref} from 'vue';

import {useVbenModal} from '@vben/common-ui';
import {useUserStore} from '@vben/stores';

import {message} from 'ant-design-vue';

import {useVbenForm} from '#/adapter/form';
import {getDrugUseList} from '#/views/doctor/doctor-reception/api';

import {createWesternMedicine, getWesternMedicineInfo, updateWesternMedicine,} from '../api';
import {modalFormProps} from '../config/form';

const userStore = useUserStore();

const drugTime = ref([]);
const drugType = ref([]);
const drugUnit = ref([]);
const drugFrequency = ref([]);
getDrugUseList().then((res) => {
  drugTime.value = res.drug_time.map((item) => {
    return {
      label: item.name,
      value: item.id,
    };
  });
  drugType.value = res.drug_use_type.map((item) => {
    return {
      label: item.name,
      value: item.id,
    };
  });
  drugUnit.value = res.drug_unit.map((item) => {
    return {
      label: item.name,
      value: item.id,
    };
  });
  drugFrequency.value = res.drug_use_frequency.map((item) => {
    return {
      label: item.name,
      value: item.id,
    };
  });
  return res;
});

const isUpdate = ref(false);
const gridApi = ref();

const [Form, formApi] = useVbenForm(modalFormProps);

const [Modal, modalApi] = useVbenModal({
  fullscreenButton: false,
  draggable: true,
  onCancel() {
    modalApi.close();
  },
  onConfirm: async () => {
    formApi.validate().then(async (e: any) => {
      if (e.valid) {
        const values = await formApi.getValues();
        modalApi.setState({ loading: true, confirmLoading: true });
        const submitApi = isUpdate.value
          ? updateWesternMedicine
          : createWesternMedicine;
        submitApi(values)
          .then(() => {
            message.success('保存成功');
            gridApi.value?.reload();
            modalApi.close();
          })
          .finally(() => {
            modalApi.setState({ loading: false, confirmLoading: false });
          });
      }
    });
    await formApi.validateAndSubmitForm();
  },
  onOpenChange(isOpen: boolean) {
    gridApi.value = isOpen ? modalApi.getData()?.gridApi : null;
    if (isOpen) {
      formApi.updateSchema([
        {
          componentProps: {
            options: drugTime.value,
          },
          fieldName: 'time_id',
        },
        {
          componentProps: {
            options: drugUnit.value,
          },
          fieldName: 'unit_id',
        },
        {
          componentProps: {
            options: drugType.value,
          },
          fieldName: 'type_id',
        },
        {
          componentProps: {
            options: drugFrequency.value,
          },
          fieldName: 'frequency_id',
        },
      ]);
      const { values, update } = modalApi.getData<Record<string, any>>();
      if (values) {
        isUpdate.value = update;

        // 如果是编辑模式且有id，获取完整详情并写入表单
        if (update && values.id) {
          getWesternMedicineInfo(values.id)
            .then((res: any) => {
              if (res) {
                // 确保introduction_images是数组格式
                // if (
                //   !detailData.introduction_images ||
                //   !Array.isArray(detailData.introduction_images)
                // ) {
                //   detailData.introduction_images = [];
                // }
                // 使用详情数据覆盖表单，确保所有字段都是最新的
                formApi.setValues({
                  ...values,
                  introduction_images: res.introduction_images,
                });

                console.log(formApi.getValues());
              } else {
                // 如果获取详情失败，使用传入的values
                formApi.setValues(values);
              }
            })
            .catch((error) => {
              console.error('获取商品详情失败:', error);
              // 获取失败时，使用传入的values
              formApi.setValues(values);
            });
        } else {
          // 新增模式，直接使用传入的values
          formApi.setValues(values);
        }
      }
    }
  },
});
</script>
<template>
  <Modal
    :title="`${isUpdate === true ? '编辑' : '新增'}西（中成）药`"
    class="w-[30%]"
  >
    <Form />
  </Modal>
</template>
